/*
 *
 * File: ComparatorData.java
 * Date: Mar 28, 2008; 4:39:58 PM
 */
package de.desy.mst.libs.accelerator;

import java.util.Comparator;

/**
 *
 * @author <a href="mailto:marcus.walla(at)desy.de">walla</a>
 * @version $Id: ComparatorData.java 12066 2008-05-29 08:35:57Z walla $
 */
public final class ComparatorData implements Comparator<IEData>
{

	/* (non-Javadoc)
	 * @see java.util.Comparator#compare(java.lang.Object, java.lang.Object)
	 */
	public int compare(final IEData data1_, final IEData data2_)
	{
		if (data1_ == null && data2_ == null)
			return 0;
		else if (data1_ == null)
			return 1;
		else if (data2_ == null)
			return -1;
		return data1_.hashCode() - data2_.hashCode();
	}

}
/* end of file */