/*
 * Created on 	Jun 10, 2005 - Jun 10, 2005, Jul 15 2005
 * 				Aug 19, 2005 ... added inSeinenWertenGleich
 * ws: Jul 06, 2007 - ...		@Deprecated to Tine Stuff
 *
 */
package de.desy.mst.libs.framework.mstapp.ini;

import java.util.HashMap;
import java.util.Map;

import de.desy.mst.libs.framework.mstapp.tabellendaten.TabellenDatenSystemIni;

/**
 * Ini Klasse fuer die System Weiten Properties
 * @author ws
 * @version 1.0.0
 */
public class SystemIni implements IIniFileObserver {
	@Deprecated public static final String TINE_NAME_SERVER_DEFAULT_ADDRESS	= "acclcens1";
	@Deprecated public static final String TINE_NAME_SERVER_ADDRESS_KEY 	= "TINE_NAME_SERVER_ADDRESS";
    
	@Deprecated public static final String TINE_NAME_SERVER_DEFAULT_ADDRESS_BACKUP	= "acclcens2";
	@Deprecated public static final String TINE_NAME_SERVER_ADDRESS_BACKUP_KEY		= "TINE_NAME_SERVER_ADDRESS_BACKUP";
    
    private Map<String, String> systemProperties = new HashMap<String, String>();//never null
    private TabellenDatenSystemIni tabellenDatenSystemIni;
    
//=============================================================================
  
    /**package private for debugging only*/
    static SystemIni createDefaultIniBaumRoot(){
        final SystemIni retVal = new SystemIni();
        final Map<String, String> properties = new HashMap<String, String>();
//        properties.put(TINE_NAME_SERVER_ADDRESS_KEY        , TINE_NAME_SERVER_DEFAULT_ADDRESS);
//        properties.put(TINE_NAME_SERVER_ADDRESS_BACKUP_KEY , TINE_NAME_SERVER_DEFAULT_ADDRESS_BACKUP );
        retVal.setSystemProperties(properties);
        return retVal;
    }
    
//=============================================================================
      
    @Override public Object getDefaultIniBaumRoot() {return createDefaultIniBaumRoot();}
    @Override public Object onPrepareForExport()    {return this;}
    /** sets new properties, if iniBaumRoot is of correct type and new properties not null*/
    @Override public void onNewIniAvailable(final Object iniBaumRoot) {
        if(! (iniBaumRoot instanceof SystemIni) ) {return;}
        final Map<String, String> properties = ((SystemIni) iniBaumRoot).getSystemProperties();
        if(properties == null ){return;}
        this.setSystemProperties(properties);
    }
    
//=============================================================================

    /**never null*/  
    @Deprecated public String getTine_Name_Server_Address() {
        return getSystemStringProperty(TINE_NAME_SERVER_ADDRESS_KEY, TINE_NAME_SERVER_DEFAULT_ADDRESS);
    }
    /**never null*/  
    @Deprecated public String getTine_Name_Server_Backup_Address() {
        return getSystemStringProperty(TINE_NAME_SERVER_ADDRESS_BACKUP_KEY, TINE_NAME_SERVER_DEFAULT_ADDRESS_BACKUP);
    }

    /**never null*/  
    public final Map<String, String> getSystemProperties() {
        return this.systemProperties;
    }
    public final void setSystemProperties(final Map<String, String> properties) {
        this.systemProperties = (properties == null) ? new HashMap<String, String>() : properties;
    }
    public final TabellenDatenSystemIni getTabellenDatenSystemIni() {
        return this.tabellenDatenSystemIni;
    }
    public final void setTabellenDatenSystemIni(final TabellenDatenSystemIni tabellenDatenSystemIni) {
        this.tabellenDatenSystemIni = tabellenDatenSystemIni;
    }

	public boolean inSeinenWertenGleich(final SystemIni otherSystemIni) {
		return inSeinenWertenGleich(otherSystemIni.getSystemProperties()) 
		    && inSeinenWertenGleich(otherSystemIni.getTabellenDatenSystemIni());
	}

//=============================================================================
    
    private String getSystemStringProperty(final String key, final String defaultString) {
        final Object candidateRetVal =this.systemProperties.get(key);
        if(candidateRetVal instanceof String){return (String) candidateRetVal;}
        else                                 {return defaultString;} 
    }

    private boolean inSeinenWertenGleich(final Map<String, String> otherSystemProperties) {
    	if(otherSystemProperties == null)	{return false;}
    	if(this.systemProperties.size() != otherSystemProperties.size())	{return false;}
    	for (final String string : this.systemProperties.keySet()) {
    		if(!otherSystemProperties.get(string).equals(this.systemProperties.get(string)))
    		{return false;}
    	}
    	for (final String string : otherSystemProperties.keySet()) {
    		if(!this.systemProperties.get(string).equals(otherSystemProperties.get(string)))
    		{return false;}
    	}
    	return true;
    }
	private boolean inSeinenWertenGleich(final TabellenDatenSystemIni otherTabellenDatenSystemIni) {
		final TabellenDatenSystemIni thisTabellenDatenSystemIni = getTabellenDatenSystemIni();
		if(thisTabellenDatenSystemIni == otherTabellenDatenSystemIni)	{return true;}
		if(thisTabellenDatenSystemIni == null)	{return false;}
		return thisTabellenDatenSystemIni.inSeinenWertenGleich(otherTabellenDatenSystemIni);
	}    
} 
