/**
 *	Jul 28, 2009 - Jul 29, 2009	ws:	creation from scratch 
 */
package de.desy.mst.libs.framework.mstapp.logging.gui;

import java.util.List;

/**
 * Specifies the features for Auto Append Support in ALogSource's
 * <br> L is a LogMessgage
 * @author ws
 * @version 1.0.0
 */
interface __IAutoAppend {
	interface IAAServer <L> {
		public boolean supportsAutoAppend();
		/**@return true, if a valid and new registration*/
		public boolean register  (final IAAClient<L> client);
		/**@return true, if client was a valid and new registration*/
		public boolean deregister(final Object       client);
	}
	interface IAAClient <L> {
		/**never null and never part of entries in onNewEntries(entries)*/
		public void onNewEntry(final L entry);
		/**never null or null entries and never entry in onNewEntry(entry)*/
		public void onNewEntries(final List<L> entries);
	}
}
