/*
 *
 * File: IEValue.java
 * Date: May 3, 2007; 3:34:15 PM
 */
package de.desy.mst.libs.accelerator;

import de.desy.mst.libs.accelerator.view.IViewContainer;

/**
 * <p>Each container or component has a list of enumerations from this 
 * enumeration interface. It depends on the current container which contains
 * different values. For example the {@code RFControl} has the {@code ON},
 * {@code OFF}, and {@code RESET} element.</p>
 * <p>This enumeration interface was firstly represented for use with the 
 * interface of {@link IViewContainer} and all derivated classes but it can
 * surely also be used in other classes or interfaces.</p> 
 * 
 * @author <a href="mailto:marcus.walla(at)desy.de">walla</a>
 * @version $Id: IEValue.java 12066 2008-05-29 08:35:57Z walla $
 */
public interface IEValue extends IEEnum
{
	
}
/* end of file */