/**
 * 
 * Last changed: $Date$
 * By: $Author$
 * URL: $HeadURL$
 * $Revision$ 
 *
 */
package de.desy.mst.libs.framework.mstapp.appinf;


/**
 * @author labudda
 *
 */
public interface IApplikationInterfaceFactory {
	/**
	 * @return true, if this kind of applikation is supported by factory
	 */
	public boolean isValidKind();
	/**
	 * @return information about applikation
	 * @throws IllegalStateException if kind of applikation is not supported by factory
	 */
	public IApp getApplicationInformation() throws IllegalStateException;

}
