/*
 * Created on 	Dec 21, 2005 - Dec 22, 2005
 *
 */
package de.desy.mst.libs.framework.mstapp.ini;

/**
 * Dieses ist ein Framework INTERNES Interface.
 * 
 * Es dient zur Synchronisation von 'maschinenNr' etc. in FileDataIni.
 * Standard IniFileObserver Methoden werden nicht aufgerufen,
 * dafr diese am Ende vor dem MstIni IniFileObserver Aufrufen.
 * Implementiert IIniFileObserver lediglich um den Standard
 * Registrierungsmechanismus verwenden zu koennen.
 * <br><br>
 * The routines are called by the IniFileObserverMgr.
 * 
 * @author schuette
 * @version 1.0.0
 */
public interface IIniFileObserver_FileDataIni extends IIniFileObserver {
	/**fileDataIni nie null<br> do synchronisation fileDataIni -> observer*/ 
	public void onNewIniAvailable(FileDataIni fileDataIni);
	/**fileDataIni nie null<br> do synchronisation observer -> fileDataIni*/ 
	public void onPrepareForExport(FileDataIni fileDataIni);
}
