/**
 *	Jul 23, 2009 - Jul 23, 2009	ws:	creation from scratch 
 *	Sep 15, 2009 - Sep 15, 2009	ws: getBaseList() private -> pp
 */
package de.desy.mst.libs.framework.mstapp.logging.gui;

import java.util.Iterator;
import java.util.List;

/**
 * Adapter for java.util.List to __IRList
 * @author ws
 * @version 1.0.0
 */
class __ListAdapt<E> implements __IRList<E> {
	private final List<E> baseList;
//-----------------------------------------------------------------------------	
	public __ListAdapt(final List<E> baseList) throws NullPointerException{
		if(baseList == null)
			throw new NullPointerException();
		this.baseList = baseList;
	}
//-----------------------------------------------------------------------------
	@Override public E   get(final int index)	{return getBaseList().get(index);}
	@Override public int size() 				{return getBaseList().size();}
	@Override public Iterator<E> iterator() 	{return getBaseList().iterator();}
	
	@Override public int hashCode() {return getBaseList().hashCode();}
	@Override public boolean equals(final Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		return getBaseList().equals(  ((__ListAdapt<?>)obj).getBaseList()   );
	}
//-----------------------------------------------------------------------------	
	/***/ List<E> getBaseList() {return this.baseList;}
}
 