/**
 * May 25, 2009 - May 26, 2009	ws:	Creation from scratch
 */
package de.desy.mst.libs.framework.mstapp.logging.map_tinelogsrv;

import de.desy.tine.server.logger.ClsLog.ClogPriority;
import de.desy.tine.server.logger.ClsLog.ClogStatus;

/**
 * handle programmatically differently
 * @author ws
 * @version 1.0.0
 */
class __ClsLogInfoNonSystem extends ClsLogInfo {
	/**@throws IllegalArgumentException if context is SystemContext*/
	__ClsLogInfoNonSystem(final String text
						, final String context
						, final String tag
						, final String caller
						, final ClogPriority 	priority
						, final ClogStatus 	status) {
		super(text, context, tag, caller, priority, status);
		if(isSystemContext(context))
			throw new IllegalArgumentException(" Der Kontext darf nicht der SystemKontext sein");
	}
//=============================================================================
	@Override public final boolean isSystemInfo() {return false;}
}
