/**
 *	Feb 15, 2008 - Feb 15, 2008 ws: added "@Override"es
 * ws:	Sep 29, 2008 - Sep 29, 2008	replaced reference by PrefManager
 */
package de.desy.mst.libs.framework.mstapp.preferences.implementation;

import de.desy.mst.libs.framework.mstapp.preferences.IPrefContainer;
import de.desy.mst.libs.framework.mstapp.preferences.helper.APrefClientPanel;
import de.desy.mst.libs.framework.mstapp.preferences.helper.APreferences;

public class PrefGeneral extends APreferences{
	private static final String TITLE = "Suchen";
	private static final String[] KEYWORDS = new String[]{};
	private PrefManager prefMgr;
//=============================================================================
	public PrefGeneral(final  PrefManager prefMgr) {
		super(PrefGeneral.TITLE, null, KEYWORDS);
		this.prefMgr = prefMgr;
	}
//=============================================================================
	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override public String toString() {return TITLE;}
	@Override public APrefClientPanel createPrefClientPanel(final IPrefContainer prefContainer) {
		return new PrefGeneralPnl(this.prefMgr, prefContainer);
	}
}
