package de.desy.mst.libs.framework.mstapp.preferences.implementation.optionPanels;

import javax.swing.JPanel;

import de.desy.mst.libs.framework.mstapp.MstApp.TineAnbindung;
import de.desy.mst.libs.framework.mstapp.logging.Logger;
import de.desy.mst.libs.framework.mstapp.preferences.IPrefClient;
import de.desy.mst.libs.framework.mstapp.preferences.IPrefContainer;
import de.desy.mst.libs.framework.mstapp.preferences.IPreferences;

@Deprecated 
public class PrefDebugLevel implements IPreferences{
	
	private JPanel jPanelPreferences=null;
	private IPreferences parent=null;
	private final String title="Tine";
	private final IPrefContainer prefContainer=null;
	private TineAnbindung tine=null;
	private int actLevel=1;
	
	public PrefDebugLevel(final TineAnbindung tine) {
		super();
		this.tine=tine;
		this.actLevel=tine.getDebugLevel();
		initialize();
	}

	public void destroyPanelPreferences() {
		this.jPanelPreferences = null;
	}

	@Override public String[] getKeyWords() {
		return new String[]{"Tine", "Debug"};
	}

	@Override public IPreferences getParent() {
		return this.parent;
	}
	
	@Override public JPanel getPrefComponent(final IPrefContainer prefContainer) {
		if (this.jPanelPreferences==null){
			this.jPanelPreferences=new PrefDebugLevelPanel(this.tine,prefContainer,this.actLevel);		
		}
		return this.jPanelPreferences;
	}

	@Override public String getTitle() {
		return this.title;
	}

	private void initialize(){
	}

	public void onRestoreDefault() {
		Logger.SWFW.info("DebugLevel onRestoreDefault ");		
	}

	@Override public final void setParent(final IPreferences parent) {
		this.parent = parent;
	}   
	@Override public IPrefClient getPrefClient() { 
		Logger.SWFW.info("DebugLevel getPreferenceClient ");		
		return (IPrefClient)this.jPanelPreferences;
	}

	@Override public void onDispose() {
		if (this.jPanelPreferences != null){
			this.jPanelPreferences.setVisible(false);
			this.jPanelPreferences = null;	//meine einzige Referenz
		}	
		Logger.SWFW.info("DebugLevel, onDispose(), actLevel= "+this.actLevel);		
	}

	
	public final IPrefContainer getPrefContainer() {
		return this.prefContainer;
	}

	@Override public final void onNewSaveString(final String saveString) {
	}
	
}
