/**
 *	Jan 15, 2008 - Jan 15, 2008	ws:	serializable
 */
package de.desy.mst.libs.framework.mstapp.util.observables.setvalue;

import java.awt.event.ItemListener;
import java.io.Serializable;

import javax.swing.AbstractButton;

/**
 * Selected Manager der Items synchronisiert
 * @author K. Hinsch -mst1-
 */
public class GuiSetSelectedManager	extends SetSelectedManager
									implements ItemListener, Serializable{
	private static final long serialVersionUID = 1L;

	public GuiSetSelectedManager(final boolean startValue) {super(startValue);}

	@Override public void itemStateChanged(final java.awt.event.ItemEvent e) {
		final Object source = e.getSource();
		if(    (this.contains(source))
				&& (source instanceof AbstractButton)   ){
			final AbstractButton selectableItem = (AbstractButton)source;
			final boolean isSelected = selectableItem.isSelected();
			this.setSelected(isSelected);
		}
	}
}