/**
 * 	Jul  8, 2010 - Jul  8, 2010	ws:	created from scratch
 */
package de.desy.mst.libs.info.appadmin;

import java.util.logging.Level;

/**
 * Only connection to the _Queue
 * <br>Handles fail safe fire(_Msg)
 * @author ws
 */
class _ExporterTo_Queue {
	private final _Queue queue;
//-----------------------------------------------------------------------------
	/**
	 * @param queue	nonnull queue for message offering
	 * @throws NullPointerException	if any parameter is null
	 */
	public _ExporterTo_Queue(final _Queue queue) {
		__Utils.checkForNull(queue, "_Queue");
		this.queue = queue;
	}
//-----------------------------------------------------------------------------
	/**failsafe firing of a complete _Msg*/
	final void fire(final _Msg msg) {
		try{getQueue().offer(msg);}
		catch(final Exception ex){_Logging.log(Level.WARNING, "Can not export the Message: " + msg, ex);}
	}
//-----------------------------------------------------------------------------
	private _Queue getQueue() {return this.queue;}
}