/*
 * Created on Apr 30, 2009
 *
 */
package de.desy.mst.libs.ser.tclientlib;

/**
 * The connection mode. TINE links can connect to servers in datagram (UDP) or
 * connection (TCP) mode. The default connection mode is DATAGRAM.
 * 
 * @author jwlg
 */
public enum TConnectionMode {
    
    /** Datagram connection (UDP) - the default. */
    DATAGRAM,
    /** Stream connection (TCP) */
    STREAM;
    
}
